/************************************************************************
 *									*
 *		hr`lCu					*
 *									*
 *				: R}h͔ŃTvvO	*
 *		t@C	: csample.c				*
 *		쐬		: s.aizawa				*
 *									*
 ************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <conio.h>
#include "isam.h"

#define	ESC	0x1b

static	void	err_proc(int);

static	void	t_search(DB *);
static	void	t_store(DB *);
static	void	t_update(DB *);
static	void	t_delete(DB *);
static	void	t_list(DB *);
static	void	t_ichiran(DB *);
static	void	t_info(DB *);
static	void	t_info_dbf(DBF *);
static	void	t_info_idx(IDX *);
static	void	t_locate(DB *);
static	void	t_etc(DB *);
static	void	t_sort(DB *);
static	void	t_pack(DB *);
static	void	t_reindex(DB *);
static	void	t_chgidx(DB *);
static	void	t_count(DB *);
static	void	t_recall(DB *);
static	void	del_mode(void);
static	void	t_flush(DB *);
static	DB	*t_dbf_create(char *);
static	void	t_idx_create(DB *);
static	void	display(DB *);
static	void	display2(DB *);
static	int	jikkou(void);
static	void	err_proc(int);
static	void	title(void);
static	void	beep(void);
static	void	stop_handler(void);

static	DB	*sv_dbp;

/*=======================================================================
 |
 |		C
 |
 |	int	main(argc, argv)
 |
 |		int	argc;		p[^
 |		char	*argv[];	R}hCp[^
 |
 =======================================================================*/
main(int argc, char *argv[])
{
	char	dbf_file_name[32];
	char	idx_file_name[32];
	DB	*dbp;
	int	loop_sw, ch;

	/* p[^`FbN */
	if (argc < 2) {
		printf("gFbr`lokd@f[^t@C@mCfbNXt@C@DDDn\n");
		exit(1);
	}

	signal(SIGINT, stop_handler);	/* rsnoL[ŏ~ */

	title();		/* ^Cg\ */

	db_err_handler(err_proc);	/* G[[`ݒ */

	/* t@CI[v */
	argc--;
	strcpy(dbf_file_name, *++argv);
	if (strchr(dbf_file_name, '.') == NULL)
		strcat(dbf_file_name, ".DBF");
	if ((dbp = db_open(dbf_file_name)) == 0) {
		for (;;) {
			printf("\nf[^t@C܂B쐬܂ (Y/N) ==>");
			ch = getch();
			printf("%c\n", ch);
			if (ch == 'Y' || ch == 'y')
				break;
			if (ch == 'N' || ch == 'n')
				exit(0);
		}
		if ((dbp = t_dbf_create(dbf_file_name)) == 0) {
			exit(1);
		}
	}
	sv_dbp = dbp;

	/* CfbNXt@CI[v */
	while (--argc) {
		strcpy(idx_file_name, *++argv);
		if (strchr(idx_file_name, '.') == NULL)
			strcat(idx_file_name, ".NDX");
		if (db_index(dbp, idx_file_name) == 0) {
			printf("file open error (%s)\n", idx_file_name);
			db_close(dbp);
			exit(1);
		}
	}

	display2(dbp);	/* JgR[h\ */

	loop_sw = 1;
	while (loop_sw) {
		printf("\n===== j[ =====\n");
		printf("1.  2.ǉ  3.XV  4.폜  5.\  6.ʒu  7.̑  8.I ==>");
		ch = getch();
		printf("%c\n", ch);
		switch (ch) {
		case '1':		/*  */
			t_search(dbp);
			break;
		case '2':		/* ǉ */
			t_store(dbp);
			break;
		case '3':		/* XV */
			t_update(dbp);
			break;
		case '4':		/* 폜 */
			t_delete(dbp);
			break;
		case '5':		/* \ */
			t_list(dbp);
			break;
		case '6':		/* ʒu */
			t_locate(dbp);
			break;
		case '7':		/* ̑ */
			t_etc(dbp);
			break;
		case '8':		/* I */
			loop_sw = 0;
			break;
		default:
			beep();
		}
	}

	db_close(dbp);

	return(0);
}

/*=======================================================================
 |
 |		
 |
 |	void	t_search(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_search(DB *dbp)
{
	IDX	*ip;
	char	buf[40];

	printf("\n=====  =====\n");

	ip = dbp->ip[dbp->master];

	if (ip == NULL) {
		printf("CfbNXt@C܂\n");
		return;
	}

	/*  */
	printf("%s ==>", ip->ihp->index);
	scanf("%s", buf);

	db_search(dbp, buf, strlen(buf));	/*  */

	display2(dbp);		/* JgR[h\ */
}

/*=======================================================================
 |
 |		ǉ
 |
 |	void	t_store(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_store(DB *dbp)
{
	DBF	*dp;
	register int	i;
	FIELD	*flp;
	char	ibuf[256], *ibp, buf[100], buf2[100], fmt[20];

	printf("\n===== ǉ =====\n");

	dp = dbp->dp;

	/* R[hobt@NA */
	memset(ibuf, ' ', dp->dhp->l_rec - 1);

	/* tB[h */
	ibp = ibuf;
	for (i = 0, flp = dp->flp; i < dp->n_field; i++, flp++) {
		printf("%-10s(%d) ==>", flp->name, flp->l_field);
		scanf("%s", buf);

		if (flp->type != 'N')
			memcpy(ibp, buf, strlen(buf));
		else {
			sprintf(fmt, "%%%d.%dlf", flp->l_field, flp->l_dec);
			sprintf(buf2, fmt, atof(buf));
			memcpy(ibp, buf2, flp->l_field);
		}

		ibp += flp->l_field;
	}

	if (i == dp->n_field) {
		if (jikkou()) {
			db_store(dbp, ibuf);	/* R[hǉ */
			display2(dbp);		/* JgR[h\ */
		}
	}
}

/*=======================================================================
 |
 |		XV
 |
 |	void	t_update(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_update(DB *dbp)
{
	DBF	*dp;
	register int	i;
	FIELD	*flp;
	char	ibuf[256], *ibp, buf[100], buf2[100], fmt[20];

	printf("\n===== XV =====\n");

	dp = dbp->dp;

	/* R[hobt@NA */
	memset(ibuf, ' ', dp->dhp->l_rec - 1);

	/* tB[h */
	ibp = ibuf;
	for (i = 0, flp = dp->flp; i < dp->n_field; i++, flp++) {
		printf("%-10s(%d) ==>", flp->name, flp->l_field);
		scanf("%s", buf);

		if (flp->type != 'N')
			memcpy(ibp, buf, strlen(buf));
		else {
			sprintf(fmt, "%%%d.%dlf", flp->l_field, flp->l_dec);
			sprintf(buf2, fmt, atof(buf));
			memcpy(ibp, buf2, flp->l_field);
		}
		
		ibp += flp->l_field;
	}

	if (i == dp->n_field) {
		if (jikkou()) {
			db_update(dbp, ibuf);	/* R[hXV */
			display2(dbp);		/* JgR[h\ */
		}
	}
}

/*=======================================================================
 |
 |		폜
 |
 |	void	t_delete(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_delete(DB *dbp)
{
	printf("\n===== 폜 =====\n");

	if (jikkou()) {
		db_delete(dbp);		/* R[h폜 */
		display2(dbp);		/* JgR[h\ */
	}
}

/*=======================================================================
 |
 |		\
 |
 |	void	t_list(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_list(DB *dbp)
{
	int	ch;
	int	loop_sw;

	loop_sw = 1;
	while (loop_sw) {
		printf("\n===== \ =====\n");
		printf("1.ꗗ  2. ==>");
		ch = getch();
		printf("%c\n", ch);
		switch (ch) {
		case '1':		/* ꗗ */
			t_ichiran(dbp);
			break;
		case '2':		/*  */
			t_info(dbp);
			break;
		case ESC:		/* ߂ */
			loop_sw = 0;
			break;
		default:
			beep();
		}
	}
}

/*=======================================================================
 |
 |		ꗗ\
 |
 |	void	t_ichiran(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_ichiran(DB *dbp)
{
	int	ch, loop_sw;

	printf("\n===== ꗗ =====\n");

	loop_sw = 1;
	while (loop_sw) {
		printf("1.擪R[h\  2.JgR[h\ ==>");
		ch = getch();
		printf("%c\n", ch);
		switch (ch) {
		case '1':	/* 擪R[h\ */
			db_top(dbp);
			loop_sw = 0;
			break;
		case '2':	/* JgR[h\ */
			loop_sw = 0;
			break;
		case ESC:	/* ߂ */
			return;
		default:
			beep();
		}
	}

	for (;;) {
		display(dbp);		/* PR[h\ */

		if (db_eof(dbp))
			break;

		db_skip(dbp, 1L);	/* R[h */

		if (kbhit()) {
			if (ch = getch()) {
				if (ch == ESC)
					break;
				else if (ch == ' ') {
					ch = getch();
					if (ch == ESC)
						break;
				}
			}
		}
	}
}

/*=======================================================================
 |
 |		\
 |
 |	void	t_info(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_info(DB *dbp)
{
	DBF	*dp;
	IDX	*ip;
	int	ch, n;

	printf("\n=====  =====\n");

	dp = dbp->dp;

	/* t@C\ */
	n = 1;
	printf("0.%s\n", dp->file_name);
	for (n = 1; n <= dbp->n_idx; n++) {
		ip = dbp->ip[n];
		printf("%d.%s\n", n, ip->file_name);
	}

	if (n == 1)
		t_info_dbf(dp);		/* t@C\ */
	else {
		for (;;) {
			printf("==>");
			ch = getch();
			printf("%c\n", ch);
			if (ch == ESC)
				break;
			else if (ch == '0') {
				t_info_dbf(dp);	/* caet@C */
				break;
			} else if (ch >= '1' && ch < n+'0') {
				t_info_idx(dbp->ip[ch-'0']);/* mcwt@C */
				break;
			} else
				beep();
		}
	}
}

/*=======================================================================
 |
 |		t@C\
 |
 |	void	t_info_dbf(dp)
 |
 |		DBF	*dp;		cae|C^
 |
 =======================================================================*/
static	void	t_info_dbf(DBF *dp)
{
	DBF_H	*dhp;
	FIELD	*flp;
	register int	i;

	dhp = dp->dhp;
	printf("*** %s *** \n", dp->file_name);
	printf("ŏIXV : %2d/%02d/%02d\n", dhp->date[0], dhp->date[1], dhp->date[2]);
	printf("R[h : %ld\n", dhp->n_rec);
	printf("R[h : %d\n\n", dhp->l_rec);
	printf("tB[h@`@@ʌ\n");
	for (i = 0, flp = dp->flp; i < dp->n_field; i++, flp++) {
		printf(" %-11s   %c     %2d     %2d\n",
				flp->name,
				flp->type,
				flp->l_field,
				flp->l_dec);
	}
}

/*=======================================================================
 |
 |		CfbNXt@C\
 |
 |	void	t_info_idx(ip)
 |
 |		IDX	*ip;		hcw|C^
 |
 =======================================================================*/
static	void	t_info_idx(IDX *ip)
{
	IDX_H	*ihp;

	ihp = ip->ihp;
	printf("*** %s *** \n", ip->file_name);
	printf("[gm : %ld\n", ihp->root);
	printf("ubN : %ld\n", ihp->n_block);
	printf("L[     : %d\n", ihp->l_key);
	printf("       : %d\n", ihp->order);
	printf("f[^ : %d\n", ihp->type);
	printf("R[h : %d\n", ihp->l_rec);
	printf("\     : %s\n", ihp->index);
}

/*=======================================================================
 |
 |		ʒu
 |
 |	void	t_locate(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_locate(DB *dbp)
{
	int	loop_sw, ch;
	char	buf[6];

	loop_sw = 1;
	while (loop_sw) {
		printf("\n===== ʒu =====\n");
		printf("1.擪  2.Ō  3.wں  4.Oړ ==>");
		ch = getch();
		printf("%c\n", ch);
		switch (ch) {
		case '1':		/* 擪 */
			db_top(dbp);
			display2(dbp);
			break;
		case '2':		/* Ō */
			db_bottom(dbp);
			display2(dbp);
			break;
		case '3':		/* wں */
			printf("R[hԍ ==>");
			scanf("%s", buf);
			db_set(dbp, atol(buf));
			display2(dbp);
			break;
		case '4':		/* Oړ */
			printf("ړR[h ==>");
			scanf("%s", buf);
			db_skip(dbp, atol(buf));
			display2(dbp);
			break;
		case ESC:		/* ߂ */
			loop_sw = 0;
			break;
		default:
			break;
		}
	}
}

/*=======================================================================
 |
 |		̑
 |
 |	void	t_etc(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_etc(DB *dbp)
{
	int	ch;
	int	loop_sw;

	loop_sw = 1;
	while (loop_sw) {
		printf("\n===== ̑ =====\n");
		printf("1.\[g  2.pbN      3.ޯč\z  4.ޯؑ  5.JEg\n");
		printf("6.    7.폜[h  8.tbV     9.ޯ쐬  ==>");
		ch = getch();
		printf("%c\n", ch);
		switch (ch) {
		case '1':		/* \[g */
			t_sort(dbp);
			break;
		case '2':		/* pbN */
			t_pack(dbp);
			break;
		case '3':		/* CfbNXč\z */
			t_reindex(dbp);
			break;
		case '4':		/* CfbNXؑ */
			t_chgidx(dbp);
			break;
		case '5':		/* JEg */
			t_count(dbp);
			break;
		case '6':		/*  */
			t_recall(dbp);
			break;
		case '7':		/* 폜[h */
			del_mode();
			break;
		case '8':		/* tbV */
			t_flush(dbp);
			break;
		case '9':		/* ޯ쐬 */
			t_idx_create(dbp);
			break;
		case ESC:		/* ߂ */
			loop_sw = 0;
			break;
		default:
			beep();
		}
	}
}

/*=======================================================================
 |
 |		\[g
 |
 |	void	t_sort(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_sort(DB *dbp)
{
	DBF	*dp;
	char	file_name[10], key[100];

	printf("\n===== \[g =====\n");

	dp = dbp->dp;

	/* o̓t@C */
	printf("o̓t@C ==>");
	scanf("%s", file_name);

	/* L[ */
	printf("L[ ==>");
	scanf("%s", key);

	if (jikkou()) {
		printf("s\n");
		dbf_sort(dp, file_name, key);	/* \[g */
	}
}

/*=======================================================================
 |
 |		pbN
 |
 |	void	t_pack(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_pack(DB *dbp)
{
	printf("\n===== pbN =====\n");

	if (jikkou()) {
		printf("s\n");
		db_pack(dbp);		/* pbN */
		display2(dbp);		/* JgR[h\ */
	}
}

/*=======================================================================
 |
 |		CfbNXč\z
 |
 |	void	t_reindex(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_reindex(DB *dbp)
{
	printf("\n===== ޯč\z =====\n");

	if (jikkou()) {
		printf("s\n");
		db_reindex(dbp);	/* CfbNXč\z */
		display2(dbp);		/* JgR[h\ */
	}
}

/*=======================================================================
 |
 |		CfbNX؂ւ
 |
 |	void	t_chgidx(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_chgidx(DB *dbp)
{
	IDX	*ip;
	int	ch;
	int	n;

	if (dbp->n_idx == 0)
		return;

	/* CfbNXt@C\ */
	printf("0.Ȃ\n");
	for (n = 1; n <= dbp->n_idx; n++) {
		ip = dbp->ip[n];
		printf("%d.%s\n", n, ip->file_name);
	}

	for (;;) {
		printf("==>");
		ch = getch();
		printf("%c\n", ch);
		if (ch == ESC)
			break;
		else if (ch >= '0' && ch < n+'0') {
			db_chgidx(dbp, ch - '0'); /* CfbNX؂ւ */
			display2(dbp);		/* JgR[h\ */
			break;
		} else
			beep();
	}
}

/*=======================================================================
 |
 |		JEg
 |
 |	void	t_count(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_count(DB *dbp)
{
	IDX	*ip;
	char	buf[40];
	long	n;

	printf("\n===== JEg =====\n");

	ip = dbp->ip[dbp->master];

	if (ip == NULL)
		return;

	/* L[f[^ */
	printf("%s ==>", ip->ihp->index);
	scanf("%s", buf);

	n = db_count(dbp, buf, strlen(buf));	/* JEg */
	printf("%5ld \n", n);			/* \ */

	display2(dbp);				/* JgR[h\ */
}

/*=======================================================================
 |
 |		
 |
 |	void	t_recall(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_recall(DB *dbp)
{
	printf("\n=====  =====\n");

	if (jikkou()) {
		db_recall(dbp);		/*  */
		display2(dbp);		/* JgR[h\ */
	}
}

/*=======================================================================
 |
 |		폜[h
 |
 |	void	del_mode(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	del_mode()
{
	int	ch;

	printf("\n===== 폜[h =====\n");

	printf("1.폜R[hL  2.폜R[h ==>");
	ch = getch();
	printf("%c\n", ch);
	if (ch == '1')
		set_deleted(0);		/* 폜R[hL */
	else if (ch == '2')
		set_deleted(1);		/* 폜R[h */
}

/*=======================================================================
 |
 |		tbV
 |
 |	void	t_flush(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_flush(DB *dbp)
{
	printf("\n===== tbV =====\n");

	if (jikkou()) {
		db_flush(dbp);		/* tbV */
		display2(dbp);		/* JgR[h\ */
	}
}

/*=======================================================================
 |
 |		t@C쐬
 |
 |	DB	*t_dbf_create(file_name)
 |
 |		char	*file_name;	t@C
 |
 =======================================================================*/
static	DB	*t_dbf_create(char *file_name)
{
	DB	*dbp;
	char	buf[10];
	int	i, ch, loop_sw;
	DBF_I	dbfi[20];

	printf("\n===== ްް쐬 =====\n");

	/* f[^t@C */
	printf("ް ̧ٖ %s\n", file_name);

	for (i = 0; ; i++) {
		/* tB[h */
		printf("tB[hiI:CTRL-Zj ==>");
		dbfi[i].name[0] = '\0';
		scanf("%s", dbfi[i].name);
		if (strlen(dbfi[i].name) == 0)
			break;

		/* tB[h` */
		printf("` (C,N,D,L) ==>");
		loop_sw = 1;
		while (loop_sw) {
			ch = getch();
			switch (ch) {
			case 'C':
			case 'c':
				dbfi[i].type = 'C';
				printf("C\n");
				loop_sw = 0;
				break;
			case 'N':
			case 'n':
				dbfi[i].type = 'N';
				printf("N\n");
				loop_sw = 0;
				break;
			case 'D':
			case 'd':
				dbfi[i].type = 'D';
				printf("D\n");
				loop_sw = 0;
				break;
			case 'L':
			case 'l':
				dbfi[i].type = 'L';
				printf("L\n");
				loop_sw = 0;
				break;
			default:
				beep();
			}
		}

		/* tB[h */
		printf(" ==>");
		scanf("%s", buf);
		dbfi[i].l_field = atoi(buf);

		/*  */
		if (dbfi[i].type == 'N') {
			printf(" ==>");
			scanf("%s", buf);
			dbfi[i].l_dec = atoi(buf);
		} else
			dbfi[i].l_dec = 0;
	}

	if (i != 0)
		dbp = db_create(file_name, dbfi, i);	/* f[^x[X쐬 */
	else
		dbp = NULL;

	return(dbp);
}

/*=======================================================================
 |
 |		CfbNXt@C쐬
 |
 |	void	t_idx_create(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	t_idx_create(DB *dbp)
{
	char	file_name[14], key[100];
	int	ch, uniq;

	printf("\n===== ޯ쐬 =====\n");

	/* CfbNXt@C */
	printf("ޯ ̧ٖ ==>");
	scanf("%s", file_name);
	strcat(file_name, ".NDX");

	/* L[ */
	printf("L[ ==>");
	scanf("%s", key);

	/* L[̏d */
	printf("L[̏d iOFL@PFj ==>");
	for (;;) {
		ch = getch();
		printf("%c\n", ch);
		if (ch == '0') {
			uniq = 0;
			break;
		} else if (ch == '1') {
			uniq = 1;
			break;
		} else
			beep();
	}
	if (jikkou()) {
		/* CfbNXt@C쐬 */
		db_idx_create(dbp, file_name, key, uniq);

		display2(dbp);	/* JgR[h\ */
	}
}

/*=======================================================================
 |
 |		R[h\iꗗ`j
 |
 |	void	display(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	display(DB *dbp)
{
	char	fmt[10];
	DBF	*dp;
	FIELD	*flp;
	int	i;

	dp = dbp->dp;
	flp = dp->flp;

	if (db_bof(dbp)) {
		printf("[BOF]\n");
	} else if (db_eof(dbp))  {
		printf("[EOF]\n");
	} else {
		dbf_read(dp, dbp->rno);
		printf("%c", *dp->rbp);
		for (i = 0; i < dp->n_field; i++) {
			sprintf(fmt, "%%.%ds", flp->l_field);
			printf(fmt, flp->fad);
			printf(" ");
			flp++;
		}
		printf("\n");
	}
}

/*=======================================================================
 |
 |		R[h\
 |
 |	void	display2(dbp)
 |
 |		DB	*dbp;		ca|C^
 |
 =======================================================================*/
static	void	display2(DB *dbp)
{
	DBF	*dp;
	register int	i;
	FIELD	*flp;
	char	fmt[20];

	printf("##### JgR[h #####\n");

	dp = dbp->dp;

	if (db_bof(dbp)) {
		printf("[BOF]\n");
	} else if (db_eof(dbp)) {
		printf("[EOF]\n");
	} else {
		dbf_read(dp, dbp->rno);
		if (*dp->rbp == '*')
			printf("*폜*\n");
		for (i = 0, flp = dp->flp; i < dp->n_field; i++, flp++) {
			sprintf(fmt, "%%-10s [%%.%ds]\n", flp->l_field);
			printf(fmt, flp->name, flp->fad);
		}
	}
}

/*=======================================================================
 |
 |		smF
 |
 |	int	jikkou()
 |
 =======================================================================*/
static	int	jikkou()
{
	int	ch;

	printf("s܂ (Y/N) ");
	for (;;) {
		ch = getch();
		if (ch == 'Y' || ch == 'y') {
			printf("%c\n", ch);
			return(1);
		} else if (ch == 'N' || ch == 'n') {
			printf("%c\n", ch);
			return(0);
		}
	}
}

/*=======================================================================
 |
 |		G[\
 |
 |	void	err_proc(err_code)
 |
 |		int	err_code;	G[R[h
 |
 =======================================================================*/
static	void	err_proc(int err_code)
{
	char	*msg;

	printf("G[bZ[W F ");
	switch (err_code) {
	case IE_MEMORY:
		msg = "s";
		break;
	case IE_FOPEN:
		msg = "t@CI[vG[ ";
		break;
	case IE_NOFILE:
		msg = "I[vt@CȂ";
		break;
	case IE_IDXOVER:
		msg = "CfbNXt@C";
		break;
	case IE_TMPFILE:
		msg = "e|t@CȂ";
		break;
	case IE_NOKEY:
		msg = "w肳ꂽL[݂Ȃ";
		break;
	case IE_DBLKEY:
		msg = "L[dĂ";
		break;
	case IE_RECNO:
		msg = "R[hԍs";
		break;
	case IE_EOF:
		msg = "ane܂͂dne";
		break;
	case IE_STRFILE:
		msg = "\t@CȂ";
		break;
	case IE_READ:
		msg = "t@CG[";
		break;
	case IE_WRITE:
		msg = "t@CG[";
		break;
	case IE_IDXKEY:
		msg = "CfbNX̃L[\s";
		break;
	default:
		msg = "??????????";
		break;
	}
	printf("%s\n", msg);
}

/*=======================================================================
 |
 |		^Cg\
 |
 |	void	title()
 |
 =======================================================================*/
static	void	title()
{

	printf("*** ISAM LIBRARY SAMPLE PROGRAM ***\n");
}

/*=======================================================================
 |
 |		addo
 |
 |	void	beep()
 |
 =======================================================================*/
static	void	beep()
{
	putch(0x07);
}

/*=======================================================================
 |
 |		rsnoL[
 |
 |	void	stop_handler()
 |
 =======================================================================*/
static	void	stop_handler(void)
{
	db_close(sv_dbp);
	printf("I܂.\n");
	exit(1);
}
